EvaluateScript("animation.js")

var deadfinished = false;

Animation.prototype.realblit = Animation.prototype.blit;
Animation.prototype.realblitMirror = Animation.prototype.blitMirror;
Animation.prototype.blit = function(x, y){
  this.max = 0;
  for(var i = 0; i < this.timing.length; i++){
    this.max += this.timing[i];
  }
  this.realblit(x, y);
  if(this.changed && this.something == 0){
     return 1;
  } else return 0;
}

Animation.prototype.blitMirror = function(x, y){
  this.max = 0;
  for(var i = 0; i < this.timing.length; i++){
    this.max += this.timing[i];
  }
  this.realblitMirror(x, y);
  if(this.changed && this.something == 0){
    return 1;
  } else return 0;
}

var player = new Object();
var enemy = new Object();

function endBattleSystem(){
  player = new Object();
  enemy = new Object();
}

function bs(a, b){
  initiateBattleSystem(a, b);
  var blah = battleSystem();
  endBattleSystem();
  return blah;
}

function initiateBattleSystem(playerHitPoints, enemySkillLevel){
  deadfinished = false;
  player.x = 0;
  player.y = 0;
  player.image = new Object();
  player.image.tempflagohshit = false;
  player.image.offset = 0;
  player.image.blit = function(x, y){
    if(this.flag == 0) this.standing.blit(x + this.offset,y);
    if(this.flag == 1) if(this.walkingforwards.blit(x + this.offset,y)) this.offset += 8;
    if(this.flag == 2) if(this.walkingbackwards.blit(x + this.offset,y)) this.offset -= 8;
    if(this.flag == 3) this.stancehigh.blit(x + this.offset,y);
    if(this.flag == 4) this.stancelow.blit(x + this.offset,y);
    if(this.flag == 5) if(this.slashinghigh.blit(x + this.offset,y)){ this.flag = 0; player.attacking = false; }
    if(this.flag == 6) if(this.slashinglow.blit(x + this.offset,y)){ this.flag = 0; player.attacking = false; }
    if(this.flag == 7) if(this.dying.blit(x + this.offset, y)){ this.flag = 8; this.tempflagohshit = true;}
    if(this.flag == 8) this.dead.blit(x + this.offset, y);
  }
  player.image.blitMirror = function(x, y){
    if(this.flag == 0) BlitMirror(this.standing, x + this.offset,y);
    if(this.flag == 1) if(this.walkingbackwards.blitMirror(x + this.offset,y)) this.offset += 8;
    if(this.flag == 2) if(this.walkingforwards.blitMirror(x + this.offset,y)) this.offset -= 8;
    if(this.flag == 3) BlitMirror(this.stancehigh, x + this.offset,y);
    if(this.flag == 4) BlitMirror(this.stancelow, x + this.offset,y);
    if(this.flag == 5) if(this.slashinghigh.blitMirror(x + this.offset,y)){ this.flag = 0; player.attacking = false; }
    if(this.flag == 6) if(this.slashinglow.blitMirror(x + this.offset,y)){ this.flag = 0; player.attacking = false; }
    if(this.flag == 7) if(this.dying.blitMirror(x + this.offset, y)){ this.flag = 8; this.tempflagohshit = true;}
    if(this.flag == 8) BlitMirror(this.dead, x + this.offset, y);
  }
  player.image.walkingforwards = new Animation();
  player.image.walkingbackwards = new Animation();
  player.image.standing = LoadImage("stickwalk1.png");
  player.image.slashinghigh = new Animation();
  player.image.slashinglow = new Animation();
  player.image.dying = new Animation();
  player.image.walkingforwards.addImage("stickwalk1.png", 150);
  player.image.walkingforwards.addImage("stickwalk2.png", 150);
  player.image.walkingforwards.addImage("stickwalk3.png", 150);
  player.image.walkingbackwards.addImage("stickwalk3.png", 150);
  player.image.walkingbackwards.addImage("stickwalk2.png", 150);
  player.image.walkingbackwards.addImage("stickwalk1.png", 150);
  player.image.stancehigh = LoadImage("stickhi.png");
  player.image.stancelow = LoadImage("sticklow.png");
  player.image.slashinghigh.addImage("stickhigh3.png", 50);
  player.image.slashinghigh.addImage("stickhigh2.png", 50);
  player.image.slashinghigh.addImage("stickhigh1.png", 50);
  player.image.slashinglow.addImage("sticklow1.png", 50);
  player.image.slashinglow.addImage("sticklow2.png", 50);
  player.image.slashinglow.addImage("sticklow3.png", 50);
  player.image.dying1 = LoadImage("dying1.png");
  player.image.dying2 = LoadImage("dying2.png");
  player.image.dying3 = LoadImage("dying3.png");
  player.image.dying4 = LoadImage("dying4.png");
  player.image.dead = LoadImage("killed.png");
  player.attacking = false;
  player.image.flag = 0;
  player.wasAttacking = false;
  player.wasHit = false;
  player.hp = playerHitPoints;
  player.canAttack = true;
  player.timer = 0;
  
  enemy.x = 0;
  enemy.y = 0;
  enemy.image = new Object();
  enemy.image.offset = 0;
  enemy.image.tempflagohshit = false;
  enemy.image.blit = function(x, y){
    if(this.flag == 0) this.standing.blit(x + this.offset,y);
    if(this.flag == 1) if(this.walkingforwards.blit(x + this.offset,y)) this.offset -= 8;
    if(this.flag == 2) if(this.walkingbackwards.blit(x + this.offset,y)) this.offset += 8;
    if(this.flag == 3) this.stancehigh.blit(x + this.offset,y);
    if(this.flag == 4) this.stancelow.blit(x + this.offset,y);
    if(this.flag == 5) if(this.slashinghigh.blit(x + this.offset,y)) this.logic = 0;
    if(this.flag == 6) if(this.slashinglow.blit(x + this.offset,y)) this.logic = 0;
    if(this.flag == 7) if(this.dying.blit(x + this.offset, y)){ this.flag = 8; this.tempflagohshit = true;}
    if(this.flag == 8) this.dead.blit(x + this.offset, y);
  }
  enemy.image.blitMirror = function(x, y){
    if(this.flag == 0) BlitMirror(this.standing, x + this.offset,y);
    if(this.flag == 1) if(this.walkingbackwards.blitMirror(x + this.offset,y)) this.offset -= 8;
    if(this.flag == 2) if(this.walkingforwards.blitMirror(x + this.offset,y)) this.offset += 8;
    if(this.flag == 3) BlitMirror(this.stancehigh, x + this.offset,y);
    if(this.flag == 4) BlitMirror(this.stancelow, x + this.offset,y);
    if(this.flag == 5) if(this.slashinghigh.blitMirror(x + this.offset,y)){ enemy.logic = 0; enemy.attacking = false; }
    if(this.flag == 6) if(this.slashinglow.blitMirror(x + this.offset,y)){ enemy.logic = 0; enemy.attacking = false; }
    if(this.flag == 7) if(this.dying.blitMirror(x + this.offset, y)){ this.flag = 8; this.tempflagohshit = true;}
    if(this.flag == 8) BlitMirror(this.dead, x + this.offset, y);
  }
  enemy.image.dying = new Animation();
  enemy.image.walkingforwards = new Animation();
  enemy.image.walkingbackwards = new Animation();
  enemy.image.standing = LoadImage("stickwalk1.png");
  enemy.image.slashinghigh = new Animation();
  enemy.image.slashinglow = new Animation();
  enemy.image.dying1 = LoadImage("dying1.png");
  enemy.image.dying2 = LoadImage("dying2.png");
  enemy.image.dying3 = LoadImage("dying3.png");
  enemy.image.dying4 = LoadImage("dying4.png");
  enemy.image.dead = LoadImage("killed.png");
  enemy.image.walkingforwards.addImage("stickwalk3.png", 150);
  enemy.image.walkingforwards.addImage("stickwalk2.png", 150);
  enemy.image.walkingforwards.addImage("stickwalk1.png", 150);
  enemy.image.walkingbackwards.addImage("stickwalk1.png", 150);
  enemy.image.walkingbackwards.addImage("stickwalk2.png", 150);
  enemy.image.walkingbackwards.addImage("stickwalk3.png", 150);
  enemy.image.stancehigh = LoadImage("stickhi.png");
  enemy.image.stancelow = LoadImage("sticklow.png");
  enemy.image.slashinghigh.addImage("stickhigh3.png", 50);
  enemy.image.slashinghigh.addImage("stickhigh2.png", 50);
  enemy.image.slashinghigh.addImage("stickhigh1.png", 50);
  enemy.image.slashinglow.addImage("sticklow1.png", 50);
  enemy.image.slashinglow.addImage("sticklow2.png", 50);
  enemy.image.slashinglow.addImage("sticklow3.png", 50);
  enemy.image.flag = 0;
  enemy.logic = 0;
  enemy.timer = 0;
  enemy.attackdelay = 0;
  enemy.attacktimer = 0;
  enemy.fearTimer = 0;
  enemy.switchTimer = 0;
  enemy.bypass = false;
  enemy.sight = 0;
  enemy.attacking = false;
  enemy.hp = 100;
  enemy.wasHit = false;
  enemy.skill = 1000 - (enemySkillLevel*100);
}
 
function battleSystem(){
  var distance = 0;
  var green = CreateColor(0, 255, 0);
  var red = CreateColor(255, 0, 0);
  var done = false;
  while(!done){
    distance = (enemy.image.offset + 490) - (player.image.offset + 150);
    player.image.blit(150, 286);
    enemy.image.blitMirror(490, 286);
    font.drawText(0, 0, "Player: ");
    font.drawText(0, font.getHeight() + 1, "Enemy: ");

    Rectangle(50, 2, 100, font.getHeight() - 4, red);
    Rectangle(50, 2, player.hp, font.getHeight() - 4, green);
    Rectangle(50, font.getHeight() + 2, 100, font.getHeight() - 4, red);
    Rectangle(50, font.getHeight() + 2, enemy.hp, font.getHeight() - 4, green);

//    if(IsKeyPressed(KEY_Q)) enemy.hp = 0;

    if(IsKeyPressed(KEY_RIGHT) && player.image.flag != 1){ //player input
      player.image.flag = 1;
      player.image.walkingforwards.reset();
    }
    if(IsKeyPressed(KEY_LEFT) && player.image.flag != 2){
      player.image.flag = 2;
      player.image.walkingbackwards.reset();
    }
    if(!IsKeyPressed(KEY_LEFT) && !IsKeyPressed(KEY_RIGHT) && !(player.image.flag == 5 || player.image.flag == 6)){
      player.image.flag = 0;
    }
    if(IsKeyPressed(KEY_UP) && player.image.flag != 5 && player.image.flag != 6){
      player.image.flag = 3;
    }
    if(IsKeyPressed(KEY_DOWN) && player.image.flag != 5 && player.image.flag != 6){
      player.image.flag = 4;
    }
    if(IsKeyPressed(KEY_DOWN) && IsKeyPressed(KEY_UP) && !player.attacking){
      player.image.flag = 0;
    }
    if(player.canAttack){
      if(!player.wasAttacking && IsKeyPressed(fightKey) && IsKeyPressed(KEY_UP) && player.image.flag == 3){
        player.attacking = true;
        player.wasAttacking = true;
        player.image.flag = 5;
        player.image.slashinghigh.reset();
        player.timer = GetTime() + 500;
        player.canAttack = false;
      }
      if(!player.wasAttacking && IsKeyPressed(fightKey) && IsKeyPressed(KEY_DOWN) && player.image.flag == 4){
        player.attacking = true;
        player.wasAttacking = true;
        player.image.flag = 6;
        player.image.slashinglow.reset();
        player.timer = GetTime() + 500;
        player.canAttack = false;
      }
    }
    if(!IsKeyPressed(fightKey) && player.wasAttacking){
      player.wasAttacking = false;
    }
    if(player.timer && player.timer < GetTime()){
      player.canAttack = true;
      player.timer = 0;
    }
    
    //begin enemy AI crap
    
    if(distance > 154) enemy.logic = 1; //walking direction
    if(distance < 148) enemy.logic = 2;

    if(distance < 154){ //if in base combat, and player moves, set reflex timer (enemy.timer)
      if(enemy.sight != player.image.flag){
        if(!enemy.bypass) enemy.timer = Math.floor(Math.random()*100 + enemy.skill/10) + GetTime();
      }
    }

    if(!enemy.bypass && enemy.timer < GetTime() && distance < 154){ //once reflex time kicks in,
      if(!enemy.attacking){ //make sure enemy isn't attacking
        if(!enemy.attackDelay && !enemy.attackTimer && enemy.sight == 0){
          enemy.logic = Math.round(Math.random()) + 3; //make a random Up/down decision
          if(!enemy.attackDelay && !enemy.attackTimer) enemy.attackTimer = Math.floor(Math.random()*100) + enemy.skill + GetTime(); //set time delay for attack
        }
        if(enemy.sight == 1) enemy.logic = 0; //if walking, do nothing
        if(enemy.sight == 2) enemy.logic = 0;
        if(enemy.sight == 3){ // if up, go up
          enemy.logic = 3;
          if(!enemy.fearTimer && !enemy.switchTimer){//set switch/bluff timer
            enemy.switchTimer = Math.floor(Math.random()*100) + enemy.skill + GetTime();
          }
        }
        if(enemy.sight == 4){ //if down, go down
          enemy.logic = 4; 
          if(!enemy.fearTimer && !enemy.switchTimer){//set switch/bluff timer
            enemy.switchTimer = Math.floor(Math.random()*100) + enemy.skill + GetTime();
          }
        }
        if(enemy.sight == 5) enemy.logic = 3; //if being attacked, defend
        if(enemy.sight == 6) enemy.logic = 4; //if being attacked, defend
      }
    }
    
    if(!enemy.bypass && enemy.switchTimer && enemy.switchTimer < GetTime()){ //if the switch/bluff timer goes off
      enemy.bypass = true;
      enemy.switchTimer = 0;
      enemy.fearTimer = Math.floor(Math.random()*enemy.skill*2) + 100 + GetTime(); //set attack/bluff delay (fear)
      if(enemy.logic == 3){ //switch stances
        enemy.logic = 4;
      } else {
        enemy.logic = 3;
      }
      enemy.switchTimer = 0;
    }
    
    if(enemy.bypass && !enemy.fearTimer){
      bypass = false; //only if there is a bug should this be executed
    }
    
    if(enemy.fearTimer && enemy.fearTimer < GetTime()){
      if(Math.round(Math.random())){ //50/50 chance to attack from switched or defend
        enemy.logic += 2;
      } else {
        enemy.logic = enemy.sight;
      }
      enemy.fearTimer = 0;
      enemy.bypass = false; //make sure you can use logic again
    }

    if(enemy.attackTimer && enemy.attackTimer < GetTime()){
      enemy.attackDelay = Math.floor(Math.random()*100) + enemy.skill + GetTime();
      enemy.attackTimer = 0;
    }
    if(enemy.attackDelay && enemy.attackDelay < GetTime()){
      enemy.logic += 2;
      enemy.attackDelay = 0;
      enemy.attackTimer = 0;
    }
    
//    if(!enemy.bypass) if(distance < 154 && distance > 148) enemy.logic = 0;

    if(!enemy.attacking && enemy.logic == 1){
      enemy.image.flag = 1;
      enemy.image.walkingforwards.reset();
    }
    if(!enemy.attacking && enemy.logic == 2){
      enemy.image.flag = 2;
      enemy.image.walkingbackwards.reset();
    }
    if(!enemy.attacking && enemy.logic == 0){
      enemy.image.flag = 0;
    }
    if(!enemy.attacking && enemy.logic == 3){
      enemy.image.flag = 3;
    }
    if(!enemy.attacking && enemy.logic == 4){
      enemy.image.flag = 4;
    }
    if(!enemy.attacking && enemy.logic == 5){
      enemy.attacking = true;
      enemy.image.flag = 5;
      enemy.image.slashinghigh.reset();
    }
    if(!enemy.attacking && enemy.logic == 6){
      enemy.attacking = true;
      enemy.image.flag = 6;
      enemy.image.slashinglow.reset();
    }

     if(distance < 154){
      if(!player.wasHit && enemy.attacking && enemy.image.flag == 5 && (player.image.flag != 3)){ player.hp -= 10; player.wasHit = true; }
      if(!player.wasHit && enemy.attacking && enemy.image.flag == 6 && (player.image.flag != 4)){ player.hp -= 10; player.wasHit = true; }
      if(!enemy.wasHit && player.attacking && player.image.flag == 5 && (enemy.image.flag != 3)){ enemy.hp -= 10; enemy.wasHit = true; }
      if(!enemy.wasHit && player.attacking && player.image.flag == 6 && (enemy.image.flag != 4)){ enemy.hp -= 10; enemy.wasHit = true; }
    }
    
    if(!enemy.attacking) player.wasHit = false;
    if(!player.attacking) enemy.wasHit = false;
    
    if(enemy.hp <= 0) done = true;
    if(player.hp <= 0) done = true;
    enemy.sight = player.image.flag;
    FlipScreen();
  }
  
  if(player.hp){
    player.image.flag = 0;
    BlitMirror(enemy.image.dying1, 490 + enemy.image.offset, 286);
    player.image.blit(150, 286);
    FlipScreen();
    Delay(100);
    BlitMirror(enemy.image.dying2, 490 + enemy.image.offset, 286);
    player.image.blit(150, 286);
    FlipScreen();
    Delay(100);
    BlitMirror(enemy.image.dying3, 490 + enemy.image.offset, 286);
    player.image.blit(150, 286);
    FlipScreen();
    Delay(100);
    BlitMirror(enemy.image.dying4, 490 + enemy.image.offset, 286);
    player.image.blit(150, 286);
    FlipScreen();
    Delay(100);
    enemy.image.flag = 8;
  }
  
  if(enemy.hp){
    enemy.image.flag = 0;
    player.image.dying1.blit(150 + player.image.offset, 286);
    enemy.image.blitMirror(490, 286);
    FlipScreen();
    Delay(100);
    player.image.dying2.blit(150 + player.image.offset, 286);
    enemy.image.blitMirror(490, 286);
    FlipScreen();
    Delay(100);
    player.image.dying3.blit(150 + player.image.offset, 286);
    enemy.image.blitMirror(490, 286);
    FlipScreen();
    Delay(100);
    player.image.dying4.blit(150 + player.image.offset, 286);
    enemy.image.blitMirror(490, 286);
    FlipScreen();
    Delay(100);
    player.image.flag = 8;
  }
    
  
  var temptimer = GetTime() + 2000;
  while(temptimer > GetTime()){
    if(!player.hp && enemy.hp)font.drawText(GetScreenWidth()/2 - font.getStringWidth("The enemy has won.")/2, 0, "The enemy has won.");
    if(!enemy.hp && player.hp)font.drawText(GetScreenWidth()/2 - font.getStringWidth("The player has won.")/2, 0, "The player has won.");
    if(!enemy.hp && !player.hp)font.drawText(GetScreenWidth()/2 - font.getStringWidth("There is no winner.")/2, 0, "There is no winner.");
    player.image.blit(150, 286);
    enemy.image.blitMirror(490, 286);
    FlipScreen();
  }
  
  if(player.hp > 0){
    return player.hp;
  } else {
    return 0;
  }
}

function BlitMirror(image, x, y){
  image.transformBlit(x, y, x - image.width, y, x - image.width, y + image.height, x, y + image.height);
}

function Delay(time){
  time += GetTime();
  while(time > GetTime()){}
}