function Item(name, description, useFunction){
  this.name = name;
  this.description = description;
  this.use = useFunction;  // function useFunction(target){...}
}

function Ability(name, description, useFunction){
  this.name = name;
  this.description = description;
  this.use = useFunction;  // function useFunction(user, target){...}
}

function Entity(name, equipment, abilities, status){
  this.name = name;
  this.equipment = equipment;
  this.abilities = abilities;
  this.status = 
}

function Equipment(head, torso, left, right, legs){
  this.head = head;
  this.headac = 0;
  this.torso = torso;
  this.torsoac = 0;
  this.left = left;
  this.leftac = 0;
  this.leftap = 0;
  this.right = right;
  this.rightac = 0;
  this.rightap = 0;
  this.legs = legs;
  this.legsac = 0;
  this.ac = 0;
  this.ap = 0;
  this.update = function(){
    this.ac = this.headac + this.torsoac + this.leftac + this.rightac + this.legsac;
    this.ap = this.leftap + this.rightap;
  }
}

function Status(maxhp, staminaCoeficient){
  this.hp = maxhp;
  this.maxhp = maxhp;
  this.stamina = 100;
  this.staminaCoeficient = staminaCoeficient;
  this.dying = false;
  this.sleeping = false;
  this.enraged = false;
  this.depressed = false;
}

var Items = new Array();

Items[0] = new Item("Bandaid", "Heals 10% HP.", 
new function(target){
  target.hp += target.maxhp*.1;
  if(target.hp > target.maxhp) target.hp = target.maxhp;
});

Items[1] = new Item("Small Medical Kit", "Heals 20% HP.", 
new function(target){
  target.hp += target.maxhp*.2;
  if(target.hp > target.maxhp) target.hp = target.maxhp;
});

Items[2] = new Item("Large Medical Kit", "Heals 40% HP.", 
new function(target){
  target.hp += target.maxhp*.4;
  if(target.hp > target.maxhp) target.hp = target.maxhp;
});

Items[3] = new Item("Water", "Restores 10% stamina.", 
new function(target){
  target.stamina += 10;
  if(target.stamina > 100) target.stamina = 100;
});

Items[4] = new Item("Sports Drink", "Restores 25% stamina.", 
new function(target){
  target.stamina += 25;
  if(target.stamina > 100) target.stamina = 100;
});

Items[5] = new Item("Power Gel", "Restores 50% stamina.", 
new function(target){
  target.stamina += 50;
  if(target.stamina > 100) target.stamina = 100;
});

Items[6] = new Item("Left Hand", "Unarmed.",
new function(target){
  target.equipment.left = Abilities[attack];
  target.equipment.leftac = 1;
  target.equipment.leftap = 10;
  target.equipment.update();
});

Items[6] = new Item("Right Hand", "Unarmed.",
new function(target){
  target.equipment.right = Abilities[attack];
  target.equipment.rightac = 1;
  target.equipment.rightap = 10;
  target.equipment.update();
});

Items[6] = new Item("Hair", "No equipment on head.",
new function(target){
  target.equipment.head = "Hair";
  target.equipment.headac = 1;
  target.equipment.update();
});

Items[6] = new Item("Shirt", "No equipment on torso.",
new function(target){
  target.equipment.head = "Shirt";
  target.equipment.headac = 1;
  target.equipment.update();
});

Items[6] = new Item("Pants", "No equipment on legs.",
new function(target){
  target.equipment.head = "Pants";
  target.equipment.headac = 1;
  target.equipment.update();
});
