function Menu(){
  this.pointer = LoadImage("pointer.png");
  this.hasFocus = true;
  this.selection = 0;
  this.items = new Array();
}

Menu.prototype.addItem = function(string){
  this.items.push(string);
}

Menu.prototype.blit = function(x, y){
  for(var i = 0; i < this.items.length; i++){
    font.drawText(x, y + i*font.getHeight(), this.items[i]);
  }
  if(this.hasFocus) this.pointer.blit(x - 6, y + this.selection*font.getHeight());
  if(AreKeysLeft() && this.hasFocus){
    switch(GetKey()){
      case KEY_UP: this.selection--; break;
      case KEY_DOWN: this.selection++; break;
      case KEY_ESCAPE: return -1; break;
      case speakKey:
      case KEY_ENTER: return this.selection+1; break;
    }
    if(this.selection < 0) this.selection = this.items.length-1;
    if(this.selection > this.items.length - 1) this.selection = 0;
  }
  return 0;
}

var MainMenu = new Menu();
MainMenu.addItem("Status");
MainMenu.addItem("Options");
MainMenu.addItem("Exit");

var ExitMenu = new Menu();
ExitMenu.addItem("No");
ExitMenu.addItem("Yes");

var OptionMenu = new Menu();
OptionMenu.addItem("Change key configuration.");
OptionMenu.addItem("Use melting effect.");
OptionMenu.addItem("Do not use melting effect.");

function configKey(){
  UnbindKey(menuKey);
  BindKey(KEY_ESCAPE, "", "");
  Speak("Voice", "Press the key you wish to use for speaking twice.");
  speakKey = GetKey();
  do{
    Speak("Voice", "Press the key you wish to use for accessing the menu twice.");
    menuKey = GetKey();
  }while(menuKey == speakKey);
  Speak("Voice", "Press the key you wish to use for fighting in battle twice.");
  fightKey = GetKey();
  Speak("Voice", "Thank you for your time.");
  SetTalkActivationKey(speakKey);
  BindKey(menuKey, "InGameMenu()", "");

}